From 7059f6f30f4f087f04dfb64925b0d756ce9e2cf8 Mon Sep 17 00:00:00 2001
From: Gluzskiy Alexandr <sss123next@list.ru>
Date: Sun, 22 May 2011 21:51:30 +0300
Subject: 	new file:   dev-lang/ocaml/files/fix-binutils-2.21.patch 
 new file:   dev-lang/ocaml/files/ocaml-rebuild.sh 	new file:  
 dev-lang/ocaml/ocaml-3.12.0-r1.ebuild 	modified:  
 www-apps/trac/trac-9999.ebuild

---
 dev-lang/ocaml/files/fix-binutils-2.21.patch |  66 ++++++++++++++
 dev-lang/ocaml/files/ocaml-rebuild.sh        |  51 +++++++++++
 dev-lang/ocaml/ocaml-3.12.0-r1.ebuild        | 131 +++++++++++++++++++++++++++
 3 files changed, 248 insertions(+)
 create mode 100644 dev-lang/ocaml/files/fix-binutils-2.21.patch
 create mode 100644 dev-lang/ocaml/files/ocaml-rebuild.sh
 create mode 100644 dev-lang/ocaml/ocaml-3.12.0-r1.ebuild

(limited to 'dev-lang')

diff --git a/dev-lang/ocaml/files/fix-binutils-2.21.patch b/dev-lang/ocaml/files/fix-binutils-2.21.patch
new file mode 100644
index 0000000..fa7664c
--- /dev/null
+++ b/dev-lang/ocaml/files/fix-binutils-2.21.patch
@@ -0,0 +1,66 @@
+From: Stephane Glondu <steph@glondu.net>
+Date: Tue, 8 Mar 2011 21:17:40 +0100
+Subject: [PATCH] Fix ocamlopt w.r.t. binutils 2.21
+MIME-Version: 1.0
+Content-Type: text/plain; charset=UTF-8
+Content-Transfer-Encoding: 8bit
+
+Bug: http://caml.inria.fr/mantis/view.php?id=5237
+Bug-Debian: http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=617404
+Authors: Eric Cooper, spiralvoice
+Reviewed-by: Stéphane Glondu <steph@glondu.net>
+---
+ asmcomp/amd64/emit.mlp |   13 +++++++------
+ asmcomp/i386/emit.mlp  |    6 +++---
+ 2 files changed, 10 insertions(+), 9 deletions(-)
+
+diff --git a/asmcomp/amd64/emit.mlp b/asmcomp/amd64/emit.mlp
+index 4a3f844..525c6e6 100644
+--- a/asmcomp/amd64/emit.mlp
++++ b/asmcomp/amd64/emit.mlp
+@@ -679,17 +679,18 @@ let fundecl fundecl =
+   emit_all true fundecl.fun_body;
+   List.iter emit_call_gc !call_gc_sites;
+   emit_call_bound_errors ();
++  begin match Config.system with
++    "linux" | "gnu" ->
++      `	.type	{emit_symbol fundecl.fun_name},@function\n`;
++      `	.size	{emit_symbol fundecl.fun_name},.-{emit_symbol fundecl.fun_name}\n`
++    | _ -> ()
++  end;
+   if !float_constants <> [] then begin
+     if macosx
+     then `	.literal8\n`
+     else `	.section	.rodata.cst8,\"a\",@progbits\n`;
+     List.iter emit_float_constant !float_constants
+-  end;
+-  match Config.system with
+-    "linux" | "gnu" ->
+-      `	.type	{emit_symbol fundecl.fun_name},@function\n`;
+-      `	.size	{emit_symbol fundecl.fun_name},.-{emit_symbol fundecl.fun_name}\n`
+-  | _ -> ()
++  end
+ 
+ (* Emission of data *)
+ 
+diff --git a/asmcomp/i386/emit.mlp b/asmcomp/i386/emit.mlp
+index 2992f29..0b1252c 100644
+--- a/asmcomp/i386/emit.mlp
++++ b/asmcomp/i386/emit.mlp
+@@ -905,12 +905,12 @@ let fundecl fundecl =
+   emit_all true fundecl.fun_body;
+   List.iter emit_call_gc !call_gc_sites;
+   emit_call_bound_errors ();
+-  List.iter emit_float_constant !float_constants;
+-  match Config.system with
++  begin match Config.system with
+     "linux_elf" | "bsd_elf" | "gnu" ->
+       `	.type	{emit_symbol fundecl.fun_name},@function\n`;
+       `	.size	{emit_symbol fundecl.fun_name},.-{emit_symbol fundecl.fun_name}\n`
+-  | _ -> ()
++  | _ -> () end;
++  List.iter emit_float_constant !float_constants
+ 
+ 
+ (* Emission of data *)
+-- 
diff --git a/dev-lang/ocaml/files/ocaml-rebuild.sh b/dev-lang/ocaml/files/ocaml-rebuild.sh
new file mode 100644
index 0000000..7dd14a4
--- /dev/null
+++ b/dev-lang/ocaml/files/ocaml-rebuild.sh
@@ -0,0 +1,51 @@
+#!/bin/sh
+# run like this: ocaml-rebuild.sh [-h | -f] [emerge_options]
+
+emerge=/usr/bin/emerge
+
+if [ "$1" = "-h" ]
+then
+	echo "usage: ocaml-rebuild.sh [-h | -f(orce)] [emerge_options]"
+	echo "With -f, 	the packages will first be unmerged and then emerged"
+	echo "with the given options to ensuree correct dependancy analysis."
+	echo "Otherwise emerge is run with the --pretend flag and the given"
+	echo "options."
+	echo "It is recommended to keep the list of rebuilt packages printed"
+	echo "in pretend mode in case something go wrong"
+	exit 1
+fi
+
+if [ "$1" = "-f" ]
+then
+	pretend=0
+	shift
+else
+	pretend=1
+fi
+
+depends=`find /var/db/pkg -name DEPEND -exec grep -l 'dev-lang/ocaml\\|dev-ml/findlib' {} \;`
+
+for dep in $depends
+do 
+  dir=`dirname $dep`
+  pkg=`basename $dir`
+  category=`cat $dir/CATEGORY`
+  slot=`cat $dir/SLOT`
+
+  tobuild=">=$category/$pkg:$slot $tobuild"
+  tobuildstr="\">=$category/$pkg:$slot\" $tobuildstr"
+done
+
+if [ "$tobuild" = "" ] ; then
+	echo "Nothing to do!"
+	exit 0
+fi
+
+echo Building $tobuildstr
+
+if [ $pretend -eq 1 ]
+then
+	$emerge --pretend $@ $tobuild
+else
+	$emerge --oneshot $@ $tobuild
+fi
diff --git a/dev-lang/ocaml/ocaml-3.12.0-r1.ebuild b/dev-lang/ocaml/ocaml-3.12.0-r1.ebuild
new file mode 100644
index 0000000..f6a3373
--- /dev/null
+++ b/dev-lang/ocaml/ocaml-3.12.0-r1.ebuild
@@ -0,0 +1,131 @@
+# Copyright 1999-2011 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header: /var/cvsroot/gentoo-x86/dev-lang/ocaml/ocaml-3.12.0.ebuild,v 1.2 2011/02/27 13:09:10 aballier Exp $
+
+EAPI="1"
+
+inherit flag-o-matic eutils multilib versionator toolchain-funcs
+
+PATCHLEVEL="3"
+MY_P="${P/_/+}"
+DESCRIPTION="Fast modern type-inferring functional programming language descended from the ML family"
+HOMEPAGE="http://www.ocaml.org/"
+SRC_URI="ftp://ftp.inria.fr/INRIA/Projects/cristal/ocaml/ocaml-$(get_version_component_range 1-2)/${MY_P}.tar.bz2
+	mirror://gentoo/${PN}-patches-${PATCHLEVEL}.tar.bz2"
+
+LICENSE="QPL-1.0 LGPL-2"
+SLOT="0"
+KEYWORDS="~alpha ~amd64 ~arm ~hppa ~ia64 ~ppc ~ppc64 ~sparc ~x86 ~x86-fbsd"
+IUSE="emacs gdbm latex ncurses +ocamlopt tk X xemacs"
+
+DEPEND="tk? ( >=dev-lang/tk-3.3.3 )
+	ncurses? ( sys-libs/ncurses )
+	X? ( x11-libs/libX11 x11-proto/xproto )
+	gdbm? ( sys-libs/gdbm )"
+RDEPEND="${DEPEND}"
+
+PDEPEND="emacs? ( app-emacs/ocaml-mode )
+	xemacs? ( app-xemacs/ocaml )"
+
+S="${WORKDIR}/${MY_P}"
+pkg_setup() {
+	# dev-lang/ocaml creates its own objects but calls gcc for linking, which will
+	# results in relocations if gcc wants to create a PIE executable
+	if gcc-specs-pie ; then
+		append-ldflags -nopie
+		ewarn "Ocaml generates its own native asm, you're using a PIE compiler"
+		ewarn "We have appended -nopie to ocaml build options"
+		ewarn "because linking an executable with pie while the objects are not pic will not work"
+	fi
+}
+
+src_unpack() {
+	unpack ${A}
+	cd "${S}"
+	epatch "${FILESDIR}"/fix-binutils-2.21.patch
+	EPATCH_SUFFIX="patch" epatch "${WORKDIR}/patches"
+}
+
+src_compile() {
+	export LC_ALL=C
+	local myconf=""
+
+	# Causes build failures because it builds some programs with -pg,
+	# bug #270920
+	filter-flags -fomit-frame-pointer
+	# Bug #285993
+	filter-mfpmath sse
+
+	# It doesn't compile on alpha without this LDFLAGS
+	use alpha && append-ldflags "-Wl,--no-relax"
+	# Fails to build on arm if >O0 is used
+	use arm && replace-flags "-O?" -O0
+
+	use tk || myconf="${myconf} -no-tk"
+	use ncurses || myconf="${myconf} -no-curses"
+	use X || myconf="${myconf} -no-graph"
+	use gdbm || myconf="${myconf} -no-dbm"
+
+	# ocaml uses a home-brewn configure script, preventing it to use econf.
+	RAW_LDFLAGS="$(raw-ldflags)" ./configure -prefix /usr \
+		--bindir /usr/bin \
+		--libdir /usr/$(get_libdir)/ocaml \
+		--mandir /usr/share/man \
+		-host "${CHOST}" \
+		-cc "$(tc-getCC)" \
+		-as "$(tc-getAS)" \
+		-aspp "$(tc-getCC) -c" \
+		-partialld "$(tc-getLD) -r" \
+		--with-pthread ${myconf} || die "configure failed!"
+
+	emake -j1 world || die "make world failed!"
+
+	# Native code generation can be disabled now
+	if use ocamlopt ; then
+		# bug #279968
+		emake -j1 opt || die "make opt failed!"
+		emake -j1 opt.opt || die "make opt.opt failed!"
+	fi
+}
+
+src_install() {
+	make BINDIR="${D}"/usr/bin \
+		LIBDIR="${D}"/usr/$(get_libdir)/ocaml \
+		MANDIR="${D}"/usr/share/man \
+		install || die "make install failed!"
+
+	# Install the compiler libs
+	dodir /usr/$(get_libdir)/ocaml/compiler-libs
+	insinto /usr/$(get_libdir)/ocaml/compiler-libs
+	doins {utils,typing,parsing}/*.{mli,cmi,cmo}
+	use ocamlopt && doins {utils,typing,parsing}/*.{cmx,o}
+
+	# Symlink the headers to the right place
+	dodir /usr/include
+	dosym /usr/$(get_libdir)/ocaml/caml /usr/include/
+
+	# Remove ${D} from ld.conf, as the buildsystem isn't $(DESTDIR) aware
+	dosed "s:${D}::g" /usr/$(get_libdir)/ocaml/ld.conf
+
+	dodoc Changes INSTALL README Upgrading
+
+	# Create and envd entry for latex input files (this definitely belongs into
+	# CONTENT and not in pkg_postinst.
+	if use latex ; then
+		echo "TEXINPUTS=/usr/$(get_libdir)/ocaml/ocamldoc:" > "${T}"/99ocamldoc
+		doenvd "${T}"/99ocamldoc
+	fi
+
+	# Install ocaml-rebuild.sh script rather than keeping it in $PORTDIR
+	dosbin "${FILESDIR}/ocaml-rebuild.sh"
+}
+
+pkg_postinst() {
+	echo
+	ewarn "OCaml is not binary compatible from version to version, so you"
+	ewarn "need to rebuild all packages depending on it, that are actually"
+	ewarn "installed on your system. To do so, you can run:"
+	ewarn "/usr/sbin/ocaml-rebuild.sh [-h | emerge options]"
+	ewarn "Which will call emerge on all old packages with the given options"
+	echo
+}
-- 
cgit v1.2.3